import threading
import paho.mqtt.client as mqtt
from logger import Logger





class MonitorPublisher(threading.Thread):
    def __init__(self, queue, broker):
        threading.Thread.__init__(self)
        self.queue = queue
        self.broker = broker
        self.setDaemon(True)

	self.nameMap = { 
                         'light': { 'oldbody':'', 'body':'', 'slot': 1, 'header': 'Licht', 'cnt': 0 },
                         'computer': { 'oldbody':'', 'body':'', 'slot': 2, 'header': 'Computer', 'cnt': 0 },
                         'laundry': { 'oldbody':'', 'body':'', 'slot': 3, 'header': 'Waschm.', 'cnt': 0 },
                         'dryer': { 'oldbody':'', 'body':'', 'slot': 4, 'header': 'Trockner', 'cnt': 0 },
                         'dishwasher': { 'oldbody':'', 'body':'', 'slot': 5, 'header': 'Spuelm.', 'cnt': 0 },
                         'freezer': { 'oldbody':'', 'body':'', 'slot': 6, 'header': 'Gefrier.', 'cnt': 0 },
                         'electricity': { 'oldbody':'', 'body':'', 'slot': 7, 'header': 'Strom', 'cnt': 0 },
                         'thermom.': { 'oldbody':'', 'body':'', 'slot': 8, 'header': 'Temp.', 'cnt': 0 },
                         'fridge': { 'oldbody':'', 'body':'', 'slot': 9, 'header': 'Gefr.T.', 'cnt': 0 },
                         'os_x': { 'oldbody':'', 'body':'', 'slot': 10, 'header': 'Server', 'cnt': 0 },
                       }

    def run(self):
        client = mqtt.Client()
        client.connect(self.broker, 1883, 60)
	client.loop_start()

        while True:
            try:
                msg = self.queue.get()
                dataBlock = msg['data']
                metadataBlock = msg['metadata']
		if 'Slave' in metadataBlock:
		     if metadataBlock['Slave'] == 'Thermometer' and metadataBlock['device'] == 'ModbusHub':
   		         metadataBlock['name'] = 'fridge'
		name = metadataBlock['name']
		Logger.log("Name: " + name)
		if name in self.nameMap:
			if name in ['light', 'computer', 'laundry', 'dryer', 'dishwasher', 'freezer', 'electricity']:
				self.nameMap[name]['body'] = str(dataBlock['power'])
			elif name == 'thermom.':
				self.nameMap[name]['body'] = "{0:.2f}".format(dataBlock['temperature2'])
			elif name == 'fridge':
				self.nameMap[name]['body'] = "{0:.2f}".format(dataBlock['t2'])

			if (self.nameMap[name]['oldbody'] != self.nameMap[name]['body']) or (self.nameMap[name]['cnt'] == 10):
				self.nameMap[name]['cnt'] = 0;
				self.nameMap[name]['oldbody'] = self.nameMap[name]['body']
				message = str(self.nameMap[name]['slot']) + " " + self.nameMap[name]['header'] + " " + self.nameMap[name]['body']
       		       	 	client.publish("IoT/Monitor/Message", message, retain=True)
				Logger.log("MonitorPublisher has sent: " + message)
			else:
				self.nameMap[name]['cnt'] += 1
		else:
			Logger.log("unknown name: " + name)
            except Exception, e:
                Logger.log("Unexcepted exception %s in MonitorPublisher: %s" % (e.__class__.__name__, str(e)))
